ExamplesBasics

Reorder animation

An example of animating when items are reordered, using Motion for Vue's layout prop.

Vue
Live exampleOpen

Source code

<script setup lang="ts">
import { motion } from 'motion-v'
import { ref, onMounted, onBeforeUnmount,type CSSProperties } from 'vue'

const initialOrder = [
    "#ff0088",
    "#dd00ee",
    "#9911ff",
    "#0d63f8",
]

const order = ref([...initialOrder])

let intervalId: number | null = null

onMounted(() => {
    intervalId = window.setInterval(() => {
        order.value = shuffle(order.value)
    }, 1000)
})

onBeforeUnmount(() => {
    if (intervalId !== null) {
        clearInterval(intervalId)
    }
})

/**
 * ==============   Utils   ================
 */
function shuffle([...array]: string[]) {
    return array.sort(() => Math.random() - 0.5)
}

/**
 * ==============   Styles   ================
 */

const spring = {
    type: 'spring',
    damping: 20,
    stiffness: 300,
}

const container: CSSProperties = {
    listStyle: 'none',
    padding: '0px',
    margin: '0px',
    position: 'relative',
    display: 'flex',
    flexWrap: 'wrap',
    gap: '10px',
    width: '300px',
    flexDirection: 'row',
    justifyContent: 'center',
    alignItems: 'center',
}

const item = {
    width: "100px",
    height: "100px",
    borderRadius: "10px",
}
</script>

<template>
    <ul :style="container">
        <motion.li
            v-for="backgroundColor in initialOrder"
            :key="backgroundColor"
            layout
            :transition="spring"
            :style="{
                ...item,
                backgroundColor,
                order: order.indexOf(backgroundColor),
            }"
        />
    </ul>
</template>

Related examples

Latest in Vue

ExamplesBasics

Reorder animation

An example of animating when items are reordered, using Motion for React's layout prop.

React
Live exampleOpen

Source code

"use client"

import { Transition } from "motion/react"
import * as motion from "motion/react-client"
import { useEffect, useState } from "react"

export default function Reordering() {
    const [order, setOrder] = useState(initialOrder)

    useEffect(() => {
        const timeout = setTimeout(() => setOrder(shuffle(order)), 1000)
        return () => clearTimeout(timeout)
    }, [order])

    return (
        <ul style={container}>
            {order.map((backgroundColor) => (
                <motion.li
                    key={backgroundColor}
                    layout
                    transition={spring}
                    style={{ ...item, backgroundColor }}
                />
            ))}
        </ul>
    )
}

const initialOrder = [
    "var(--hue-1)",
    "var(--hue-2)",
    "var(--hue-3)",
    "var(--hue-4)",
]

/**
 * ==============   Utils   ================
 */
function shuffle([...array]: string[]) {
    return array.sort(() => Math.random() - 0.5)
}

/**
 * ==============   Styles   ================
 */

const spring: Transition = {
    type: "spring",
    damping: 20,
    stiffness: 300,
}

const container: React.CSSProperties = {
    listStyle: "none",
    padding: 0,
    margin: 0,
    position: "relative",
    display: "flex",
    flexWrap: "wrap",
    gap: 10,
    width: 300,
    flexDirection: "row",
    justifyContent: "center",
    alignItems: "center",
}

const item: React.CSSProperties = {
    width: 100,
    height: 100,
    borderRadius: "10px",
}

Related examples

Latest in React